image: docker:latest

services:
  - docker:dind

stages:
  - test
  - package
  - push-package

variables:
  chartname: roundcube

lint:
  stage: test
  image:
    name: alpine/helm
    entrypoint: [""]
  script:
    - helm version
    - helm dependency update
    - helm lint . -f values.lint.yaml

package:
  stage: package
  image:
    name: alpine/helm
    entrypoint: [""]
  script:
    - helm dependency update
    - helm package .
  artifacts:
    paths:
      - "*.tgz"
    expire_in: 1 year

push-package:
  stage: push-package
  image:
    name: alpine/helm:3.9.3
    entrypoint: [""]
  script:
    - export HELM_CHART_VERSION=$(helm show chart . | grep '^version:' | cut -d ':' -f1)
    - echo $CI_REGISTRY_PASSWORD | helm registry login $CI_REGISTRY
      --username $CI_REGISTRY_USER --password-stdin
    - helm push "$(echo *tgz)" oci://$CI_REGISTRY_IMAGE/${chartname}
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  dependencies:
    - package
